package com.example.controller;

import com.example.domain.Owner;
import com.example.domain.Pet;
import com.example.dto.OwnerDto;
import com.example.dto.PetDto;
import jakarta.inject.Singleton;

@Singleton
public class Mapper {

    public PetDto toPetDto(Pet pet) {
        PetDto petDto = new PetDto();
        petDto.setId(pet.getId());
        petDto.setName(pet.getName());
        petDto.setType(pet.getType());
        petDto.setOwner(toOwnerDto(pet.getOwner()));
        return petDto;
    }

    public OwnerDto toOwnerDto(Owner owner) {
        OwnerDto ownerDto = new OwnerDto();
        ownerDto.setAge(owner.getAge());
        ownerDto.setId(owner.getId());
        ownerDto.setName(owner.getName());
        return ownerDto;
    }

}
