package com.example;

import io.micronaut.http.HttpRequest;
import io.micronaut.http.HttpResponse;
import io.micronaut.http.HttpStatus;
import io.micronaut.http.client.HttpClient;
import io.micronaut.http.client.annotation.Client;
import io.micronaut.runtime.EmbeddedApplication;
import io.micronaut.test.extensions.junit5.annotation.MicronautTest;
import org.junit.jupiter.api.Test;
import org.junit.jupiter.api.Assertions;

import jakarta.inject.Inject;
import reactor.core.publisher.Flux;

import java.util.List;
import java.util.Map;

import static org.junit.jupiter.api.Assertions.assertEquals;

@MicronautTest(transactional = false)
class HibernateReactiveOracleTest {

    @Inject
    @Client("/")
    HttpClient client;

    private void init() {
        HttpResponse<Void> response = client.toBlocking().exchange(HttpRequest.GET("/init"));
        assertEquals(HttpStatus.OK, response.getStatus());
    }

    @Test
    void shouldFetchPetByNameParallel() {
        init();
        List<Map> resultsList = Flux.range(1, 1000)
                .flatMap(it -> client.retrieve(HttpRequest.GET("/pets/Dino"), Map.class))
                .collectList()
                .block();

        resultsList.forEach(it -> assertEquals("Dino", it.get("name")));
    }
}
